//

package TestUtilitiesAddon.pkg


// Launches ALL the tests in this file
+ launch_testutilitiesaddon_test_battery
  RES = ExecuteQuery("test_testexcomparestring_procedures")
  - RES
  nop
  RES = ExecuteQuery("test_testexcomparequery_procedures")
  - RES
  nop
  RES = ExecuteQuery("test_testexcomparequeryarray_procedures")
  - RES
  nop
  RES = ExecuteQuery("test_testexcompareobjects_procedures")
  - RES
  nop
  RES = ExecuteQuery("test_testexmatch_procedures")
  - RES
// -----------------------------------

// Patterns of simple and multiple response querys for the tests
+ testpattern_testquery1
  - testquery1 result

+ testpattern_testquery2
  - testquery2 result

+ testpattern_testqueryarray1
  - a - first element
  - b - second element

+ testpattern_testqueryarray2
  - 1 - first element
  - 2 - second element
  - 3 - third element

+ testpattern_testdialog1
  - Option 1.1
    option 1.2
    option 1.3
  + 1
    - first result
  + 2
    - second result
  + 3
    - third result

+ testpattern_testdialog2
  - Option 2.1
    option 2.2
  + 1
    - first result
  + 2
    - second result


// Tests for comparison of strings
+ test_testexcomparestring_procedures
  call TestExInitializeBattery("TestUtilitiesAddon -> TestExCompareString() Test Battery", "")
  STRING1 = "string 1"
  STRING2 = "string 2"
  STRING1_1 = "string 1"
  call TestExCompareString(STRING1, STRING1)
  call TestExCompareString(STRING1, STRING1_1)
  call TestExCompareStringNotEqual(STRING1, STRING2)
  call TestExGetBatteryResults()

// Tests for comparison of querys
+ test_testexcomparequery_procedures
  call TestExInitializeBattery("TestUtilitiesAddon -> TestExCompareQuery() Test Battery", "")
  QUERY1RESULT = "testquery1 result"
  QUERY2RESULT = "testquery2 result"
  call TestExCompareQuery(QUERY1RESULT, "testpattern_testquery1")
  call TestExCompareQuery(QUERY2RESULT, "testpattern_testquery2")
  call TestExCompareQueryNotEqual(QUERY2RESULT, "testpattern_testquery1")
  call TestExCompareQueryNotEqual(QUERY1RESULT, "testpattern_testquery2")
  call TestExGetBatteryResults()

// Tests for comparison of querys with multiple responses
+ test_testexcomparequeryarray_procedures
  call TestExInitializeBattery("TestUtilitiesAddon -> TestExCompareQueryArray() Test Battery", "") 
  CONTAINS1 = "a - first element"
  CONTAINS2 = "b - second element"
  NONARRAY = "this is not an array"
  ARRAY1 = ()
  ARRAY1[0] = CONTAINS1
  ARRAY1[1] = CONTAINS2
  ARRAY2 = ()
  ARRAY2[0] = "1 - first element"
  ARRAY2[1] = "2 - second element"
  ARRAY2[2] = "3 - third element"
  // This 2 commented tests were written to test detecting non-objects
  //call TestExCompareQueryArray(NONARRAY, "testpattern_testqueryarray1")
  //call TestExCompareQueryArrayNotEqual(NONARRAY, "testpattern_testqueryarray1")
  call TestExCompareQueryArray(ARRAY1, "testpattern_testqueryarray1")
  call TestExCompareQueryArrayNotEqual(ARRAY2, "testpattern_testqueryarray1")
  call TestExCompareQueryArrayNotEqual(ARRAY1, "testpattern_testqueryarray2")
  call TestExCompareQueryArray(ARRAY2, "testpattern_testqueryarray2")
  call TestExGetBatteryResults()

// Tests for comparison of objects
+ test_testexcompareobjects_procedures
  call TestExInitializeBattery("TestUtilitiesAddon -> TestExCompareObjects() Test Battery", "") 
  NONOBJ1 = "not object #1"
  NONOBJ2 = "not object #2"
  OBJ1 = ""
  OBJ1.ID = 1
  OBJ1.TEXT = "sample object 1"
  OBJ1COPY = ""
  OBJ1COPY.ID = 1
  OBJ1COPY.TEXT = "sample object 1"
  OBJ2 = ""
  OBJ2.ID = 2
  OBJ2COPY.TEXT = "sample object 1"
  OBJ3 = ""
  OBJ3.ID = 1
  OBJ3COPY.TEXT = "sample object 3"
  // This 6 commented tests were written to test detecting non-objects
  //call TestExCompareObjects(NONOBJ1, NONOBJ2)
  //call TestExCompareObjects(OBJ1, NONOBJ2)
  //call TestExCompareObjects(NONOBJ1, OBJ1COPY)
  //call TestExCompareObjectsNotEqual(NONOBJ1, NONOBJ2)
  //call TestExCompareObjectsNotEqual(OBJ1, NONOBJ2)
  //call TestExCompareObjectsNotEqual(NONOBJ1, OBJ1COPY)
  call TestExCompareObjects(OBJ1, OBJ1)
  call TestExCompareObjects(OBJ1, OBJ1COPY)
  call TestExCompareObjectsNotEqual(OBJ1, OBJ2)
  call TestExCompareObjectsNotEqual(OBJ1, OBJ3)
  call TestExGetBatteryResults()

// Tests for query matching domains
+ test_testexmatch_procedures
  call TestExInitializeBattery("TestUtilitiesAddon -> TestExMatch() Test Battery", "")
  call TestExMatch("/Spanish/Test/Test_Spanish_Test_TestUtilitiesAddon", "testpattern_testquery1")
  call TestExMatchNotEqual("/Spanish/Test/Test_Spanish_Test_TestUtilitiesAddon", "blablabla")
  call TestExMatch("/Spanish/Main", "blablabla")
  call TestExMatch("/Spanish/Chat/Agent_es", "¿Eres un robot?")
  call TestExMatchNotEqual("/Spanish/Test/Test_Spanish_Test_TestUtilitiesAddon", "¿Eres un robot?")
  call TestExGetBatteryResults()

+ test_testexdialog
  call TestExInitializeBattery("TestUtilitiesAddon -> TestExDialog() Test Battery", "")
  EXPECTEDRES = ()
  EXPECTEDRES[0] = "first result"
  EXPECTEDRES[1] = "second result"
  EXPECTEDRES[2] = "third result"
  EXPECTEDRES2 = ()
  EXPECTEDRES2[0] = "first result"
  EXPECTEDRES2[1] = "second result"
  DIALOGRESP = ()
  DIALOGRESP[0] = "1"
  DIALOGRESP[1] = "2"
  DIALOGRESP[2] = "3"
  DIALOGRESP2 = ()
  DIALOGRESP2[0] = "1"
  DIALOGRESP2[1] = "2"
  call TestExDialog(EXPECTEDRES,DIALOGRESP,"testpattern_testdialog1")
  call TestExDialog(EXPECTEDRES2,DIALOGRESP2,"testpattern_testdialog2")
  // This 3 commented tests were written to test detecting different number of parameters and other outputs
//  call TestExDialog(EXPECTEDRES,DIALOGRESP,"testpattern_testdialog2")
//  call TestExDialog(EXPECTEDRES2,DIALOGRESP,"testpattern_testdialog2")
//  call TestExDialog(EXPECTEDRES,DIALOGRESP2,"testpattern_testdialog2")
  call TestExGetBatteryResults()

// Example of simple query test
+ test_examplesimplequerytest_procedures
  call TestExInitializeBattery("Example query Test Battery", "")
  QUERY1RESULT = "testquery1 result"
  call TestExMatch("/Spanish/Test/Test_Spanish_Test_TestUtilitiesAddon", "testpattern_testquery1")
  call TestExCompareQuery(QUERY1RESULT, "testpattern_testquery1")
  call TestExGetBatteryResults()

// Example of multi response query test
+ test_examplemultiresponsequerytest_procedures
  call TestExInitializeBattery("Example query Test Battery", "")
  ARRAY2 = ()
  ARRAY2[0] = "1 - first element"
  ARRAY2[1] = "2 - second element"
  ARRAY2[2] = "3 - third element"
  call TestExMatch("/Spanish/Test/Test_Spanish_Test_TestUtilitiesAddon", "testpattern_testqueryarray2")
  call TestExCompareQueryArray(ARRAY2, "testpattern_testqueryarray2")
  call TestExGetBatteryResults()
